/**
 * @file   analyse_frequence.h
 * @author Sebastien Varrette <Sebastien.Varrette@imag.fr>
 * @date   Mon Apr 10 2006  
 *
 * Copyright (c) 2006 Sebastien Varrette  (http://www-id.imag.fr/~svarrett/)
 *
 * @brief  
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * Sebastien Varrette                               \n
 * <Sebastien.Varrette@imag.fr>                     \n
 * University of Luxembourg / ID-IMAG Laboratory    \n
 * 162-A avenue de la faiencerie                    \n
 * L-1511 Luxembourg, LUXEMBOURG                    \n
 */
 /********************************************************************************/
#ifndef __ANALYSE_FREQUENCE_H
#define __ANALYSE_FREQUENCE_H

#include "chiffrement_affine.h"

typedef struct {
    char   c;    // le caractre
    double freq; // la frquence d'apparition, en %
} letter_freq_t ;

// Effectue l'analyse frquentielle du fichier chiffr filein et tente de le dchiffrer
// Dans la comparaison entre l'analyse de frquence du texte et la rfrence des textes 
// franais, les  nb_line_to_show sont montres
int get_freq_analysis(char * filein, int nb_line_to_show);




#endif  // __ANALYSE_FREQUENCE_H




