/**
 * @file   chiffrement_affine.h
 * @author Sebastien Varrette <Sebastien.Varrette@imag.fr>
 * @date   Mon Apr 10 2006  
 *
 * Copyright (c) 2006 Sebastien Varrette  (http://www-id.imag.fr/~svarrett/)
 *
 * @brief  
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * Sebastien Varrette                               \n
 * <Sebastien.Varrette@imag.fr>                     \n
 * University of Luxembourg / ID-IMAG Laboratory    \n
 * 162-A avenue de la faiencerie                    \n
 * L-1511 Luxembourg, LUXEMBOURG                    \n
 */
 /********************************************************************************/
#ifndef __CHIFFREMENT_AFFINE_H
#define __CHIFFREMENT_AFFINE_H

#include "tools.h"

#define A_SIZE 26

/* Correspondances entre A=[a-z] et Z/26Z */
int char_to_Z26(char c, int * res);
int Z26_to_char(int i, char * res);

/* Chiffrement/Dechiffrement affine d'un lment de Z/26Z*/
int chiffrement_affine_Z26(int a, int b, int x, int * res);
int dechiffrement_affine_Z26(int inv_a, int b, int y, int * res);

/* Chiffrement/Dechiffrement affine d'un fichier */
int chiffrement_affine_Z26_fichier(int a, int b, char * filein, char * fileout);
int chiffrement_affine_Z26_n_fichier(int a, int b, int nb_char, char * filein);
int dechiffrement_affine_Z26_fichier(int inv_a, int b, char * filein, char * fileout);
int dechiffrement_affine_Z26_n_fichier(int a, int b, int nb_char, char * filein);

#endif  // __CHIFFREMENT_AFFINE_H




