/**
 * @file   tools.h
 * @author Sebastien Varrette <Sebastien.Varrette@imag.fr>
 * @date   Mon Apr 10 2006  
 *
 * Copyright (c) 2006 Sebastien Varrette  (http://www-id.imag.fr/~svarrett/)
 *
 * @brief Quelques fonctions utiles 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * Sebastien Varrette                               \n
 * <Sebastien.Varrette@imag.fr>                     \n
 * University of Luxembourg / ID-IMAG Laboratory    \n
 * 162-A avenue de la faiencerie                    \n
 * L-1511 Luxembourg, LUXEMBOURG                    \n
 */
 /********************************************************************************/
#ifndef __TOOLS_H
#define __TOOLS_H

// Calcul du pgcd
int pgcd(int a, int b);
int pgcd_rec(int a, int b);

// Calcul des coefficients de Bezout (renvoit d=pgcd(a,b) avec d=a*u + b*v
int bezout(int a, int b, int * u, int * v);

// Calcule l'inverse de a mod n. Renvoit 0 en cas de succs, 1 sinon (a non inversible)
int inv_mod(int a, int n, int * res);


#endif   // __TOOLS_H
